import QtQuick 2.10
import QtQuick.Controls 2.10
import Qt.labs.folderlistmodel 2.10
import "." as Ext
import EQL5 1.0

Rectangle {
    id: fileBrowser
    objectName: "file_browser"
    anchors.fill: parent
    visible: false

    function urlToString(url) { return url.toString().substring("file://".length) }

    Rectangle {
        id: header
        width: fileBrowser.width
        height: headerColumn.height
        z: 2
        color: "#f0f0f0"

        Column {
            id: headerColumn

            Row {
                id: buttonRow
                spacing: 4

                // one directory up
                Ext.DialogButton {
                    text: "\uf062"
                    onClicked: Lisp.call("dialogs:set-file-browser-path", urlToString(folderModel.parentFolder))
                }

                // storage
                Ext.DialogButton {
                    text: "\uf0c7"
                    onClicked: Lisp.call("dialogs:set-file-browser-path", ":storage")
                }

                // documents
                Ext.DialogButton {
                    text: "\uf0f6"
                    onClicked: Lisp.call("dialogs:set-file-browser-path", ":data")
                }

                // home
                Ext.DialogButton {
                    text: "\uf015"
                    onClicked: Lisp.call("dialogs:set-file-browser-path", ":home")
                }
            }

            TextField {
                id: path
                objectName: "path"
                width: fileBrowser.width
                inputMethodHints: Qt.ImhNoAutoUppercase | Qt.ImhNoPredictiveText
                text: urlToString(folderModel.folder)

                onAccepted: Lisp.call("dialogs:set-file-name", text)
            }
        }

        // back
        Ext.DialogButton {
            x: header.width - width
            text: "\uf105"

            onClicked: {
                fileBrowser.visible = false
                Lisp.call("dialogs:set-file-name", "")
            }
        }
    }

    ListView {
        id: folderView
        objectName: "folder_view"
        y: header.height
        width: parent.width
        height: parent.height - y
        delegate: Ext.FileDelegate {}
        currentIndex: -1 // no initial highlight
        footerPositioning: ListView.OverlayHeader

        property var colors: ["white", "#f0f0f0"]

        model: FolderListModel {
            id: folderModel
            objectName: "folder_model"
            showDirsFirst: true
            showHidden: true
            nameFilters: ["*.lisp", "*.lsp", "*.asd", "*.fas", "*.fasb", "*.fasc", ".eclrc"]
        }

        Row {
            y: 5
            anchors.horizontalCenter: parent.horizontalCenter
            spacing: 15
            visible: path.focus

            // cursor back
            Ext.ArrowButton {
                opacity: 0.1
                text: "\uf137"

                onPressed:      path.cursorPosition--
                onPressAndHold: path.cursorPosition = 0
            }

            // cursor forward
            Ext.ArrowButton {
                opacity: 0.1
                text: "\uf138"

                onPressed:      path.cursorPosition++
                onPressAndHold: path.cursorPosition = path.length
            }
        }

        footer: Rectangle {
            width: fileBrowser.width
            height: itemCount.height + 4
            z: 2
            color: "lightgray"
            border.width: 1
            border.color: "gray"

            Row {
                anchors.fill: parent

                Text {
                    id: itemCount
                    text: Lisp.call("cl:format", null, " ~D item~P", folderModel.count, folderModel.count)
                    anchors.verticalCenter: parent.verticalCenter
                }
            }
        }
    }
}
